package eu.atosresearch.health.prescripciones.client;

import java.util.List;

import com.google.gwt.user.client.rpc.AsyncCallback;

import eu.atosresearch.health.prescripciones.shared.AlarmaBean;
import eu.atosresearch.health.prescripciones.shared.MedicamentoBean;
import eu.atosresearch.health.prescripciones.shared.PacienteBean;
import eu.atosresearch.health.prescripciones.shared.PautaBean;
import eu.atosresearch.health.prescripciones.shared.TomaBean;

/**
 * The async counterpart of <code>BackendService</code>.
 */
public interface BackendServiceAsync {
	void accesoPermitido(String teleasistente, String pass, AsyncCallback<Boolean> callback) throws IllegalArgumentException;
	void getPautas(String teleasistente, AsyncCallback<List<PautaBean>> callback) throws IllegalArgumentException;
	void getTomas(String teleasistente, AsyncCallback<List<TomaBean>> callback) throws IllegalArgumentException;
	
	void getPacientes(String teleasistente, AsyncCallback<List<PacienteBean>> callback) throws IllegalArgumentException;
	void datosPaciente(String id, AsyncCallback<PacienteBean> callback) throws IllegalArgumentException;
	
	void getMedicamento(String idMedicamento, AsyncCallback<MedicamentoBean> callback) throws IllegalArgumentException;
	
	void getAlarmas(String teleasistente, AsyncCallback<List<AlarmaBean>> callback) throws IllegalArgumentException;
	void deleteAlarma(String alarmaId, AsyncCallback<Boolean> callback) throws IllegalArgumentException;
	void obtenerHistoricoAlarmas(AsyncCallback<List<AlarmaBean>> callback) throws IllegalArgumentException;
	void almacenarAlarma(AlarmaBean alarma, String queSeHace, String cuandoSeHace, AsyncCallback<AlarmaBean> callback) throws IllegalArgumentException;
}
