package eu.atosresearch.health.prescripciones.client.widgets;

import java.util.ArrayList;
import java.util.List;

import com.allen_sauer.gwt.log.client.Log;
import com.google.gwt.user.client.ui.Composite;
import com.google.gwt.user.client.ui.DialogBox;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.VerticalPanel;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.PushButton;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.user.client.ui.Image;
import com.google.gwt.user.client.ui.HasHorizontalAlignment;

import eu.atosresearch.health.prescripciones.client.ControladorAlarmas;
import eu.atosresearch.health.prescripciones.client.ControladorPautas;
import eu.atosresearch.health.prescripciones.client.widgets.alarmas.AlarmaFilaWidget;
import eu.atosresearch.health.prescripciones.client.widgets.alarmas.HistoricoAlarmasDialogWidget;
import eu.atosresearch.health.prescripciones.client.widgets.pautas.PautasListadasDialogWidget;
import eu.atosresearch.health.prescripciones.client.widgets.pautas.SeleccionPacienteDialogWidget;
import eu.atosresearch.health.prescripciones.shared.AlarmaBean;


public class PrincipalAlarmasWidget extends Composite {
	
	private List<AlarmaFilaWidget> alarmasWidgets;
	private VerticalPanel verticalPanelTablaAlarmas = new VerticalPanel();

	public PrincipalAlarmasWidget() {
		Log.debug("Creación del widget PrincipalAlarmasWidget");
		
		VerticalPanel verticalPanel = new VerticalPanel();
		verticalPanel.setWidth("100%");
		initWidget(verticalPanel);
		
		//Actualización asíncrona de pautas y tomas presentes en el sistema
		ControladorPautas.getInstance().refrescarPautasYTomas();
		
		VerticalPanel verticalPanelBotonera = new VerticalPanel();
		verticalPanelBotonera.setWidth("100%");
		verticalPanelBotonera.setHorizontalAlignment(HasHorizontalAlignment.ALIGN_RIGHT);
		verticalPanel.add(verticalPanelBotonera);
		
		HorizontalPanel horizontalPanel = new HorizontalPanel();
		verticalPanelBotonera.add(horizontalPanel);
		horizontalPanel.setHorizontalAlignment(HasHorizontalAlignment.ALIGN_RIGHT);
		horizontalPanel.setSpacing(9);
		
		PushButton pshbtnGestinDePautas = new PushButton("Gestión de pautas");
		pshbtnGestinDePautas.setTitle("Gestión de pautas");
		pshbtnGestinDePautas.getUpFace().setImage(new Image("images/bottleofpills_64.png"));
		pshbtnGestinDePautas.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				Log.debug("Diálogo de pautas...");
				PautasListadasDialogWidget pautasDialog = new PautasListadasDialogWidget();
				pautasDialog.center();
				pautasDialog.show();
			}
		});
		
		PushButton pshbtnPaciente = new PushButton("Paciente");
		pshbtnPaciente.setTitle("Ver pautas por paciente");
		pshbtnPaciente.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				Log.debug("Diálogo de selección de paciente...");
				SeleccionPacienteDialogWidget seleccionPacienteDialog = new SeleccionPacienteDialogWidget();
				seleccionPacienteDialog.center();
				seleccionPacienteDialog.show();
				seleccionPacienteDialog.setAutoHideEnabled(true);
			}
		});
		pshbtnPaciente.getUpFace().setImage(new Image("images/pacientes_64.png"));
		horizontalPanel.add(pshbtnPaciente);
		horizontalPanel.add(pshbtnGestinDePautas);
		
		PushButton pshbtnHistricoAlarmas = new PushButton("Histórico alarmas");
		pshbtnHistricoAlarmas.setTitle("Histórico alarmas");
		pshbtnHistricoAlarmas.getUpFace().setImage(new Image("images/alarm_64.png"));
		pshbtnHistricoAlarmas.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				Log.debug("Botón histórico alarmas");
				HistoricoAlarmasDialogWidget historico = new HistoricoAlarmasDialogWidget();
				historico.center();
				historico.show();
			}
		});
		horizontalPanel.add(pshbtnHistricoAlarmas);
		
		PushButton pshbtnAyuda = new PushButton("Ayuda");
		pshbtnAyuda.setTitle("Ayuda");
		pshbtnAyuda.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				DialogBox dialogoAyuda = new DialogBox();
				//String htmlAyuda = "<p>Ayuda</p><p></p><p>Gestione las alarmas actuales pendientes o pulse en los botones:</p>" +
				//		"<ul><li>Ver el archivo de alarmas</li><li>Consultar la pauta de un paciente</li><li>Consultar las pautas del sistema</li></ul><p></p><p></p>";
				
				String htmlAyuda = "<h2><span style=''>Ayuda</span></h2>En el menú principal encontrará:<br><h3>Cabecera</h3>No olvide cerrar sesión para finalizar o cambiar de usuarioteleasistente.<br><h3>Opciones - Módulos</h3><table style='text-align: left; width: 100%;' border='0' cellpadding='2' cellspacing='2'>  <tbody>    <tr>      <td><img style='width: 32px; height: 32px;' alt='pacientes' src='images/pacientes_64.png'></td>      <td>Ver pautas por paciente</td>    </tr>    <tr>      <td><img style='width: 32px; height: 32px;' alt='pautas' src='images/bottleofpills_64.png'></td>      <td>Ver pautas cargadas en el sistema de TeleasistenciaPAUTA</td>    </tr>    <tr>      <td><img style='width: 32px; height: 32px;' alt='historico' src='images/alarm_64.png'></td>      <td>Ver histórico de alarmas</td>    </tr>  </tbody></table><h3>Gestión de alarmas</h3><table style='text-align: left; width: 100%;' border='0' cellpadding='2' cellspacing='2'>  <tbody>    <tr>      <td><img style='width: 30px; height: 30px;' alt='info' src='images/iconsweets2/1361747207_information.png'></td>      <td>Detalle</td>    </tr>    <tr>      <td><img style='width: 30px; height: 30px;' alt='desestimar' src='images/iconsweets2/1361747217_drawers.png'></td>      <td>Asumir alarma</td>    </tr>    <tr>      <td><img style='width: 30px; height: 30px;' alt='sms' src='images/iconsweets2/1361747173_phone_telephone_call.png'></td>      <td>Enviar SMS o llamar al teléfono</td>    </tr>    <tr>      <td><img style='width: 30px; height: 30px;' alt='mail' src='images/iconsweets2/1361747195_email_envelope.png'></td>      <td>Enviar email de información</td>    </tr>  </tbody></table><br><br><div style='margin-left: 40px;'>Proyecto Pauta<br>Atos S.A.</div>";
				
				dialogoAyuda.add(new HTML(htmlAyuda));
				dialogoAyuda.center();
				dialogoAyuda.show();
				dialogoAyuda.setAutoHideEnabled(true);
			}
		});
		pshbtnAyuda.getUpFace().setImage(new Image("images/ayudaglobo_64.png"));
		horizontalPanel.add(pshbtnAyuda);
		
		Label lblAlarmas = new Label("Alarmas");
		lblAlarmas.setStyleName("labelTituloSeccion");
		verticalPanel.add(lblAlarmas);
		
		VerticalPanel verticalPanelContenedorTabla = new VerticalPanel();
		verticalPanelContenedorTabla.setStyleName("panelTablaAlarmas");
		verticalPanel.add(verticalPanelContenedorTabla);
		
		//ScrollPanel scrollPanel = new ScrollPanel();
		//scrollPanel.setWidget(verticalPanelTablaAlarmas);
		//scrollPanel.setWidth("" + (getParent().getOffsetWidth() - 90) + "px");
		//verticalPanelContenedorTabla.add(scrollPanel);
		
		verticalPanelContenedorTabla.add(verticalPanelTablaAlarmas);
		verticalPanelTablaAlarmas.setSize("100%", "100%");
		
		//actualizarListaAlarmas();	
	}

	public void actualizarListaAlarmas() {
		Log.info("Actualiza alarmas cargadas en el visualizador");
		alarmasWidgets = new ArrayList<AlarmaFilaWidget>();
		List<AlarmaBean> alarmasCargadas = ControladorAlarmas.getInstance().getAlarmasCargadas();
		verticalPanelTablaAlarmas.clear();
		
		for (AlarmaBean alarmaActual : alarmasCargadas) {
			Log.debug("Nueva alarma: " + alarmaActual.getId());
			AlarmaFilaWidget alarmaFilaWidget = new AlarmaFilaWidget(alarmaActual);
			alarmasWidgets.add(alarmaFilaWidget);
			verticalPanelTablaAlarmas.add(alarmaFilaWidget);
			Log.debug("Widget-fila creado para la alarma " + alarmaActual.getId());
		}
		
	}
	
	
	public AlarmaFilaWidget obtenerWidgetFila(String alarmaId) {
		for (AlarmaFilaWidget fila : alarmasWidgets) {
			if (fila.getAlarmaDelWidget().getId().equalsIgnoreCase(alarmaId))
				return fila;
		}
		return null;
	}

}
