package eu.atosresearch.health.prescripciones.client.widgets.alarmas;

import java.util.Date;

import com.allen_sauer.gwt.log.client.Log;

import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.ui.DialogBox;

import eu.atosresearch.health.prescripciones.client.Controlador;
import eu.atosresearch.health.prescripciones.client.ControladorAlarmas;
import eu.atosresearch.health.prescripciones.client.MailService;
import eu.atosresearch.health.prescripciones.client.MailServiceAsync;
import eu.atosresearch.health.prescripciones.shared.AlarmaBean;
import com.google.gwt.user.client.ui.VerticalPanel;
import com.google.gwt.user.client.ui.Grid;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.TextBox;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.HasHorizontalAlignment;
import com.google.gwt.core.client.GWT;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.i18n.client.DateTimeFormat;
import com.google.gwt.user.client.ui.RichTextArea;

public class AccionMailDialogWidget extends DialogBox {

	private final MailServiceAsync mailService = GWT.create(MailService.class);
	private TextBox textBoxPara;
	private TextBox textBoxAsunto;
	private RichTextArea richTextArea;
	private Label lblResultado;
	
	public AccionMailDialogWidget(final AlarmaBean alarma) {
		setHTML("Enviar email");
		
		VerticalPanel verticalPanel = new VerticalPanel();
		setWidget(verticalPanel);
		verticalPanel.setSize("100%", "100%");
		
		Grid grid = new Grid(3, 2);
		grid.setCellSpacing(3);
		grid.setCellPadding(3);
		verticalPanel.add(grid);
		
		Label lblPara = new Label("Para:");
		grid.setWidget(0, 0, lblPara);
		
		textBoxPara = new TextBox();
		grid.setWidget(0, 1, textBoxPara);
		textBoxPara.setWidth("393px");
		textBoxPara.setText(Controlador.getInstance().getPacienteBean(alarma.getPacienteId()).getContactoEmail());
		
		Label lblAsunto = new Label("Asunto:");
		grid.setWidget(1, 0, lblAsunto);
		
		textBoxAsunto = new TextBox();
		grid.setWidget(1, 1, textBoxAsunto);
		textBoxAsunto.setWidth("393px");
		textBoxAsunto.setText("PAUTA TELEASISTENCIA - Alarma de prioridad " + alarma.getPrioridad() + ": " + alarma.getPacienteId());
		
		Label lblTexto = new Label("Texto:");
		grid.setWidget(2, 0, lblTexto);
		
		richTextArea = new RichTextArea();
		grid.setWidget(2, 1, richTextArea);
		richTextArea.setSize("393px", "261px");
		richTextArea.setText("Fecha: " + alarma.getFecha() + "\n" + 
							 "Paciente: " + alarma.getId() + "\n" +  
							 "Descripción: " + alarma.getDescripcion() + "\n" + 
							 "...");
		
		HorizontalPanel horizontalPanelBotones = new HorizontalPanel();
		horizontalPanelBotones.setHorizontalAlignment(HasHorizontalAlignment.ALIGN_RIGHT);
		horizontalPanelBotones.setSpacing(15);
		verticalPanel.add(horizontalPanelBotones);
		
		Button btnEnviar = new Button("Enviar");
		btnEnviar.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				Log.debug("Enviar email");
				mailService.enviarEmailAEnviar(textBoxPara.getText(), textBoxAsunto.getText(), richTextArea.getText(), new AsyncCallback<String>() {
					public void onFailure(Throwable caught) {
						// Show the RPC error message to the user
						Log.error("Error al enviar el email." + caught);
						lblResultado.setText("Error al enviar el email");
						//hide();
					}
					public void onSuccess(String resultado) {
						Log.info("Envío de email ejecutado.");
						lblResultado.setText("Email enviado");
						Date ahoramismo = new Date();
						ControladorAlarmas.getInstance().almacenarAlarmaHistorico(alarma, "Envío email", DateTimeFormat.getFormat("dd-MM-yyyy hh:mm").format(ahoramismo));
						hide();
					}
				});		
			}
		});
		horizontalPanelBotones.add(btnEnviar);
		
		Button btnCancelar = new Button("Cancelar");
		btnCancelar.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				Log.debug("Cancel email");
				hide();
			}
		});
		horizontalPanelBotones.add(btnCancelar);
		
		lblResultado = new Label("");
		lblResultado.setStyleName("labelError");
		horizontalPanelBotones.add(lblResultado);
		
		
		
	}

}
