package eu.atosresearch.health.prescripciones.client.widgets.pautas;

import java.util.List;

import com.allen_sauer.gwt.log.client.Log;
import com.google.gwt.user.client.ui.DialogBox;

import eu.atosresearch.health.prescripciones.client.ControladorPautas;
import eu.atosresearch.health.prescripciones.shared.PautaBean;

import com.google.gwt.user.client.ui.ScrollPanel;
import com.google.gwt.user.client.ui.VerticalPanel;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.Grid;
import com.google.gwt.user.client.ui.Image;
import com.google.gwt.user.client.ui.HasVerticalAlignment;

public class PautasListadasDialogWidget extends DialogBox {

	public PautasListadasDialogWidget() {
		setHTML("Pautas en el sistema");
		
		ScrollPanel scrollPanel = new ScrollPanel();
		setWidget(scrollPanel);
		scrollPanel.setSize("699px", "377px");
		
		VerticalPanel verticalPanel = new VerticalPanel();
		verticalPanel.setSpacing(10);
		scrollPanel.setWidget(verticalPanel);
		verticalPanel.setSize("100%", "100%");
		
		
		
		Label lblLasPautasCargadas = new Label("Las pautas cargadas en el sistema son:");
		verticalPanel.add(lblLasPautasCargadas);
		
		try {
			List<PautaBean> pautas = ControladorPautas.getInstance().getPautasCargadas();
			Log.debug("Pautas para mostrar en el listado de pautas: " + pautas.size());
			
			Grid grid = new Grid(pautas.size() + 1, 5);
			grid.setCellPadding(9);
			grid.setStyleName("gridHistoricoAlarmas");
			
			Label lblPauta = new Label("Pauta");
			lblPauta.setStyleName("gridPautaColumnaHoy");
			grid.setWidget(0, 1, lblPauta);
			lblPauta.setWidth("120px");
			
			Label lblPaciente = new Label("Paciente");
			lblPaciente.setStyleName("gridPautaColumnaHoy");
			grid.setWidget(0, 2, lblPaciente);
			lblPaciente.setWidth("120px");
			
			Label lblFechaDeInicio = new Label("Fecha de inicio");
			lblFechaDeInicio.setStyleName("gridPautaColumnaHoy");
			grid.setWidget(0, 3, lblFechaDeInicio);
			lblFechaDeInicio.setWidth("140px");
			
			Label lblFechaDeFin = new Label("Fecha de fin");
			lblFechaDeFin.setStyleName("gridPautaColumnaHoy");
			grid.setWidget(0, 4, lblFechaDeFin);
			lblFechaDeFin.setWidth("140px");
			
			
			int fila = 1;
			for (PautaBean pauta : pautas) {
				grid.setWidget(fila, 0, new Image("images/iconsweets2/1361747232_edit.png"));
				grid.setWidget(fila, 1, new Label(pauta.getId()));
				grid.setWidget(fila, 2, new Label(pauta.getPacienteId()));
				grid.setWidget(fila, 3, new Label(pauta.getFechaInicio() + " " + pauta.getHoraInicio()));
				grid.setWidget(fila, 4, new Label(pauta.obtenerTomas().get(pauta.obtenerTomas().size()-1).getHora()));
				fila++;
			}
			
			verticalPanel.add(grid);
		} catch (NullPointerException npex) {
			Log.debug("No hay pautas");
			lblLasPautasCargadas.setText(lblLasPautasCargadas.getText() + " 0");
		}
		
		Button btnAceptar = new Button("Aceptar");
		btnAceptar.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				hide();
			}
		});
		verticalPanel.add(btnAceptar);
		verticalPanel.setCellVerticalAlignment(btnAceptar, HasVerticalAlignment.ALIGN_BOTTOM);
				
	}

}
