package eu.atosresearch.health.prescripciones.server.vademecum;

import org.apache.commons.configuration.ConfigurationException;
import org.apache.commons.configuration.PropertiesConfiguration;
import org.apache.log4j.Logger;

import eu.atosresearch.health.prescripciones.shared.MedicamentoBean;

public class ConsultaMedicamento {

	static Logger logger = Logger.getLogger(ConsultaMedicamento.class);
	
	public static MedicamentoBean getMedicamento(String id) {

		PropertiesConfiguration medicamentos = new PropertiesConfiguration();
		try {
			medicamentos.load(ConsultaMedicamento.class.getClassLoader().getResourceAsStream("eu/atosresearch/health/prescripciones/server/vademecum/vademecum.properties"));
			logger.debug("Vademecum cargado correctamente.");
		} catch (ConfigurationException ex) {
		    logger.error("Exception cargando vademecum: ", ex);
		}
		
		MedicamentoBean mb = new MedicamentoBean();
		mb.setId(id);
		mb.setPpoActivo(medicamentos.getString(id+".ppoActivo"));
		mb.setUbicacion(medicamentos.getString(id+".ubicacion"));
		mb.setObservaciones(medicamentos.getString(id+".observaciones"));
		mb.setCriticidad(medicamentos.getString(id+".criticidad"));
		mb.setDosis(medicamentos.getString(id+".dosis"));
				
		return mb;
	}
	
	
}
